import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class GoToDialog extends JDialog
{
  private JFrame parentWindow;
  private TwoContentArea contentArea;
  private JTextField lineText;

  public GoToDialog(JFrame myParentWindow, TwoContentArea myContentArea)
  {
    super(myParentWindow, "Go To Line", true);
    parentWindow = myParentWindow;
    contentArea = myContentArea;

    getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.X_AXIS));
      JPanel linePanel = new JPanel();
      linePanel.setLayout(new GridLayout(2, 1, 5, 5));
      linePanel.setBorder(new EmptyBorder(5, 5, 5, 2));
        JLabel lineLabel = new JLabel("Line Number:");
        lineText = new JTextField();
        lineLabel.setLabelFor(lineText);
        linePanel.add(lineLabel);
        linePanel.add(lineText);
      getContentPane().add(linePanel);
      JPanel buttonPanel = new JPanel();
      buttonPanel.setLayout(new GridLayout(2, 1, 5, 5));
      buttonPanel.setBorder(new EmptyBorder(5, 3, 5, 5));
        JButton okButton = new JButton("OK");
        okButton.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent event)
        {
          try { contentArea.goToLine(Integer.parseInt(lineText.getText())); }
          catch(Exception e) { JOptionPane.showMessageDialog(parentWindow, "Invalid line number", "Error", JOptionPane.ERROR_MESSAGE); }
          dispose();
        } });
        buttonPanel.add(okButton);
        JButton cancelButton = new JButton("Cancel");
        cancelButton.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent event)
          { dispose(); } });
        buttonPanel.add(cancelButton);
      getContentPane().add(buttonPanel);
    pack();
    setLocationRelativeTo(parentWindow);
    setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
    setResizable(false);
    setVisible(true);
  }
}
