import java.io.*;
import java.awt.event.*;
import javax.swing.*;
//import TerpOfficeAppInterface;

public class TwoPad extends JFrame implements TerpOfficeAppInterface
{
  // main() is provided for standalone program usage
  private static boolean runningStandalone = false;
  public static void main(String args[])
  {
    runningStandalone = true;
    TwoPad program = new TwoPad();
    try
    {
      program.launch(new File(args[0]));
    }
    catch(ArrayIndexOutOfBoundsException e)
    {
      program.launch(null);
    }
  }

  protected TwoContentArea contentArea;
  public void launch(File initialFile)
  {
    setSize(600, 400);

    // Configure System's Close Operation
    setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    addWindowListener(new WindowAdapter() { public void windowClosing(WindowEvent event) { close(); } });

    // Prepare Window Contents
    contentArea = new TwoContentArea(this, initialFile);
    new TwoMenus(this, contentArea);
    JScrollPane scrollPane = new JScrollPane(contentArea);
    scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    getContentPane().add(scrollPane);
    contentArea.scrollPane = scrollPane;

    // Display Window
    validate();
    setVisible(true);
  }

  private boolean isRunning = true;
  public boolean alive() { return isRunning; }

  public void close()
  {
    if(contentArea.closeDocument(runningStandalone) || !runningStandalone)
    {
      setVisible(false);
      dispose();
      isRunning = false;
      if(runningStandalone) { System.exit(0); }
    }
  }
}
