import javax.swing.text.*;
import javax.swing.event.*;

class TwoStyledDocument extends DefaultStyledDocument
{
  public TwoStyledDocument(Content c, StyleContext s) { super(c, s); }
  public TwoStyledDocument(StyleContext s) { super(s); }
  public TwoStyledDocument() { super(); }
  public void twoPasteStyledText(int pastePosition, String pasteText, AttributeSet[] characterAttributes, AttributeSet[] paragraphAttributes)
  {
    int currentLength;
    for(int currentPosition = 0; currentPosition < pasteText.length();)
    {
      currentLength = 1;
      try { while(characterAttributes[currentPosition + currentLength] == null) { currentLength++; } } catch(ArrayIndexOutOfBoundsException e) { }
      try { insertString(pastePosition + currentPosition, pasteText.substring(currentPosition, currentPosition + currentLength), characterAttributes[currentPosition]); } catch(BadLocationException e) { }
      currentPosition += currentLength;
    }
    try
    {
      writeLock();
/*
This code causes problems with undo/redo for some reason
      for(int counter = startPosition; counter < endPosition; counter++)
      {
This won't properly apply blocks of character attributes anyway, so I guess it's good that the undo/redo bug showed up
        if(characterAttributes[counter - startPosition] != null)
        {
          DefaultDocumentEvent characterChanges = new DefaultDocumentEvent(counter, 1, DocumentEvent.EventType.CHANGE);
          buffer.change(counter, 1, characterChanges);
          MutableAttributeSet currentAttributes = (MutableAttributeSet)getCharacterElement(counter).getAttributes();
          currentAttributes.removeAttributes(currentAttributes);
          currentAttributes.addAttributes(characterAttributes[counter - startPosition]);
          characterChanges.end();
          fireChangedUpdate(characterChanges);
        }
      }
*/
      int startIndex = getDefaultRootElement().getElementIndex(pastePosition);
      int endIndex = getDefaultRootElement().getElementIndex(pastePosition + pasteText.length() - 1);
      int forStartIndex = (pastePosition == getDefaultRootElement().getElement(startIndex).getStartOffset() ? startIndex : startIndex + 1);
      int forEndIndex = ((pastePosition + pasteText.length()) == getDefaultRootElement().getElement(endIndex).getEndOffset() - 1 ? endIndex : endIndex - 1);
      for(int counter = forStartIndex; counter <= forEndIndex; counter++)
      {
        DefaultDocumentEvent paragraphChanges = new DefaultDocumentEvent(getDefaultRootElement().getElement(counter).getStartOffset(), 1, DocumentEvent.EventType.CHANGE);
	MutableAttributeSet currentAttributes = (MutableAttributeSet)getDefaultRootElement().getElement(counter).getAttributes();
        currentAttributes.removeAttributes(currentAttributes);
        currentAttributes.addAttributes(paragraphAttributes[counter - startIndex]);
        paragraphChanges.end();
        fireChangedUpdate(paragraphChanges);
      }
    }
    finally { writeUnlock(); }
  }
}
