/*
 * attributes.java
 *
 * Created on April 3, 2002, 10:49 PM
 */

/**
 *
 * @author  Marshall
 */
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.text.*;

public class attributes extends javax.swing.JDialog {

    public static final int INCH = Toolkit.getDefaultToolkit().getScreenResolution();
    public BufferedImage im;
    /*
     *If inches: lastSelected = 1
     *If cm: lastSelected = 2
     *If pixels: lastSelected = 3
     */
    public int lastSelected = 3;
    public String w = new String();
    public String h = new String();
    public double pixelWidth, pixelHeight, inchWidth, inchHeight, cmWidth, cmHeight;
    
    /** Creates new form attributes */
    public attributes(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();        
        im = ((Faint)this.getParent()).center.getBufferedImage();        
        
        pixelWidth = im.getWidth();
        pixelHeight = im.getHeight();
        cmWidth = Math.round((pixelWidth/((double)INCH * (double)2.54))*100)/100.0;
        cmHeight = Math.round((pixelHeight/((double)INCH * (double)2.54))*100)/100.0;
        inchWidth = Math.round((pixelWidth/(double)INCH) * 100)/100.0;
        inchHeight = Math.round((pixelHeight/(double)INCH) *100)/100.0;
        
        w = w.valueOf(pixelWidth);        
        h = h.valueOf(pixelHeight);
        
        widthText.setText(w);
        heightText.setText(h);
        
        if ( ((Faint)this.getParent()).grayscaleFlag == 0 ){
            colorScale.setSelected(true);
        }
        else{
            blackwhite.setSelected(true);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        unitsButtons = new javax.swing.ButtonGroup();
        colors = new javax.swing.ButtonGroup();
        okCancel = new javax.swing.JPanel();
        ok = new javax.swing.JButton();
        cancel = new javax.swing.JButton();
        buttonsText = new javax.swing.JPanel();
        units = new javax.swing.JPanel();
        inches = new javax.swing.JRadioButton();
        cm = new javax.swing.JRadioButton();
        pixels = new javax.swing.JRadioButton();
        widthHeight = new javax.swing.JPanel();
        widthText = new javax.swing.JTextField();
        heightText = new javax.swing.JTextField();
        Height = new javax.swing.JLabel();
        Width = new javax.swing.JLabel();
        color = new javax.swing.JPanel();
        colorScale = new javax.swing.JRadioButton();
        blackwhite = new javax.swing.JRadioButton();
        
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        okCancel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        ok.setText("OK");
        ok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        okCancel.add(ok, gridBagConstraints1);
        
        cancel.setText("CANCEL");
        cancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        okCancel.add(cancel, gridBagConstraints1);
        
        getContentPane().add(okCancel, java.awt.BorderLayout.EAST);
        
        buttonsText.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        units.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints3;
        
        units.setBorder(new javax.swing.border.TitledBorder("Units"));
        inches.setText("Inches");
        unitsButtons.add(inches);
        inches.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                inchesActionPerformed(evt);
            }
        });
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.insets = new java.awt.Insets(0, 0, 0, 10);
        units.add(inches, gridBagConstraints3);
        
        cm.setText("Cm");
        unitsButtons.add(cm);
        cm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmActionPerformed(evt);
            }
        });
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.insets = new java.awt.Insets(0, 10, 0, 10);
        units.add(cm, gridBagConstraints3);
        
        pixels.setSelected(true);
        pixels.setText("Pixels");
        unitsButtons.add(pixels);
        pixels.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pixelsActionPerformed(evt);
            }
        });
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.insets = new java.awt.Insets(0, 10, 0, 0);
        units.add(pixels, gridBagConstraints3);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.insets = new java.awt.Insets(20, 0, 0, 0);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        buttonsText.add(units, gridBagConstraints2);
        
        widthHeight.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints4;
        
        widthText.setColumns(5);
        widthText.setMaximumSize(new java.awt.Dimension(4, 20));
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.gridx = 1;
        gridBagConstraints4.gridy = 0;
        widthHeight.add(widthText, gridBagConstraints4);
        
        heightText.setColumns(5);
        heightText.setMaximumSize(new java.awt.Dimension(4, 20));
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.gridx = 4;
        gridBagConstraints4.gridy = 0;
        widthHeight.add(heightText, gridBagConstraints4);
        
        Height.setText("Height");
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.gridx = 3;
        gridBagConstraints4.gridy = 0;
        gridBagConstraints4.insets = new java.awt.Insets(0, 30, 0, 0);
        widthHeight.add(Height, gridBagConstraints4);
        
        Width.setText("Width");
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.gridx = 0;
        gridBagConstraints4.gridy = 0;
        widthHeight.add(Width, gridBagConstraints4);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 0;
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        buttonsText.add(widthHeight, gridBagConstraints2);
        
        color.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints5;
        
        color.setBorder(new javax.swing.border.TitledBorder(new javax.swing.border.EtchedBorder(), "Color"));
        colorScale.setText("color");
        colors.add(colorScale);
        gridBagConstraints5 = new java.awt.GridBagConstraints();
        gridBagConstraints5.insets = new java.awt.Insets(0, 0, 0, 10);
        color.add(colorScale, gridBagConstraints5);
        
        blackwhite.setText("black and white");
        colors.add(blackwhite);
        gridBagConstraints5 = new java.awt.GridBagConstraints();
        gridBagConstraints5.insets = new java.awt.Insets(0, 10, 0, 0);
        color.add(blackwhite, gridBagConstraints5);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 2;
        gridBagConstraints2.insets = new java.awt.Insets(20, 0, 0, 0);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        buttonsText.add(color, gridBagConstraints2);
        
        getContentPane().add(buttonsText, java.awt.BorderLayout.WEST);
        
        pack();
    }//GEN-END:initComponents

    private void okActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okActionPerformed
        // Add your handling code here:
        //If the Width and Height aren't the same as they started out, then
        //you need to crop the image.
        double currWidth = Double.parseDouble(widthText.getText());
        double currHeight = Double.parseDouble(heightText.getText());
        double x1 = im.getMinX();
        double y1 = im.getMinY();
            
        if (lastSelected == 1){
            //inches
            double newPixW = Math.round((currWidth*(double)INCH) * 100)/100.0;
            double newPixH = Math.round((currHeight*(double)INCH) * 100)/100.0;            
            
            ((Faint)this.getParent()).center.resizeImage((int)newPixW, (int)newPixH);            
        }
        if (lastSelected == 2){
            //cm
            double newPixW = Math.round((currWidth * (double)INCH) * (double)2.54 * 100)/100.0;
            double newPixH = Math.round((currHeight * (double)INCH) * (double)2.54 * 100)/100.0;
            
            ((Faint)this.getParent()).center.resizeImage((int)newPixW, (int)newPixH);
        }
        if (lastSelected == 3){
            //pixels
            ((Faint)this.getParent()).center.resizeImage((int)currWidth, (int)currHeight);
        }      
        
        im = ((Faint)this.getParent()).center.getBufferedImage();
        //check to see if they want to change to black&white or color
        if (blackwhite.isSelected()){
            if ( ((Faint)this.getParent()).grayscaleFlag == 0 ){
                BufferedImage gray = new BufferedImage(im.getWidth(),im.getHeight(),BufferedImage.TYPE_BYTE_GRAY);
                Graphics2D g = gray.createGraphics();
                
                g.drawImage(im,im.getMinX(),im.getMinY(),im.getWidth(),im.getHeight(),null);
                ((Faint)this.getParent()).center.setBufferedImage(gray);
                             
                ((Faint)this.getParent()).changeToGray();
                ((Faint)this.getParent()).grayscaleFlag = 1;
            }
        }
        if (colorScale.isSelected()){            
            if ( ((Faint)this.getParent()).grayscaleFlag == 1 ){
                BufferedImage cImg = new BufferedImage(im.getWidth(),im.getHeight(),BufferedImage.TYPE_INT_RGB);
                Graphics2D g = cImg.createGraphics();
                
                g.drawImage(im,im.getMinX(),im.getMinY(),im.getWidth(),im.getHeight(),null);
                ((Faint)this.getParent()).center.setBufferedImage(cImg);
                ((Faint)this.getParent()).grayscaleFlag = 0;                
            }
        }
        
        //Close the window when you're done
        setVisible(false);
        dispose();
    }//GEN-LAST:event_okActionPerformed

    private void pixelsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pixelsActionPerformed
        // Add your handling code here:
        //change widthText from cm or inches to pixels        
        w = w.valueOf(pixelWidth);        
        h = h.valueOf(pixelHeight);
        
        widthText.setText(w);
        heightText.setText(h);
        
        lastSelected = 3;
    }//GEN-LAST:event_pixelsActionPerformed

    private void cmActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmActionPerformed
        // Add your handling code here:
        //change widthText from pixels or inches to centimeters
        if (lastSelected == 1){
            //converting from inches            
            
            double width = Double.parseDouble(widthText.getText());
            double height = Double.parseDouble(heightText.getText());
            
            width = width/(double)2.54;
            height = height/(double)2.54;
            
            width = Math.round(width*100)/100.0;
            height = Math.round(height*100)/100.0;
            
            w = w.valueOf(width);
            h = h.valueOf(height);
            
            //after we've calculated the values, we finally set the text
            widthText.setText(w);
            heightText.setText(h);
        }
        if (lastSelected == 3){
            //converting from pixels
            w = w.valueOf(cmWidth);
            h = h.valueOf(cmHeight);
            
            //after we've calculated the values, we finally set the text
            widthText.setText(w);
            heightText.setText(h);            
        }
        
        lastSelected = 2;
    }//GEN-LAST:event_cmActionPerformed

    private void inchesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_inchesActionPerformed
        // Add your handling code here:
        //change widthText from pixels or centimeters to inches        
        if (lastSelected == 2){
            //converting from cm            
            
            double width = Double.parseDouble(widthText.getText());
            double height = Double.parseDouble(heightText.getText());
            
            width = width * (double)2.54;
            height = height * (double)2.54;
                        
            width = Math.round(width*100)/100.0;
            height = Math.round(height*100)/100.0;
            
            w = w.valueOf(width);
            h = h.valueOf(height);
            
            //after we've calculated the values, we finally set the text
            widthText.setText(w);
            heightText.setText(h);
        }
        if (lastSelected == 3){
            w = w.valueOf(inchWidth);
            h = h.valueOf(inchHeight);
            
            //after we've calculated the values, we finally set the text
            widthText.setText(w);
            heightText.setText(h);            
        }
        
        lastSelected = 1;
    }//GEN-LAST:event_inchesActionPerformed

    private void cancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelActionPerformed
        // Add your handling code here:
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new attributes(new javax.swing.JFrame(), true).show();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup unitsButtons;
    private javax.swing.ButtonGroup colors;
    private javax.swing.JPanel okCancel;
    private javax.swing.JButton ok;
    private javax.swing.JButton cancel;
    private javax.swing.JPanel buttonsText;
    private javax.swing.JPanel units;
    private javax.swing.JRadioButton inches;
    private javax.swing.JRadioButton cm;
    private javax.swing.JRadioButton pixels;
    private javax.swing.JPanel widthHeight;
    private javax.swing.JTextField widthText;
    private javax.swing.JTextField heightText;
    private javax.swing.JLabel Height;
    private javax.swing.JLabel Width;
    private javax.swing.JPanel color;
    private javax.swing.JRadioButton colorScale;
    private javax.swing.JRadioButton blackwhite;
    // End of variables declaration//GEN-END:variables

}
