import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;

public class curveTool implements ourTool {
    private int startX, startY;
    private boolean dragged = false;
    private BufferedImage curImage, backupImage;
    private Stroke curveStroke;
    private int firstX, firstY, secondX, secondY;
    private int lineEndX, lineEndY;
    private int clicks = 1;
    private Graphics2D g2D;
    
    public curveTool() {
        super();
        curveStroke = new BasicStroke(1);
    }
    
    public void clickAction(MouseEvent mevt, main_canvas theCanvas) {
        if (clicks == 1) {
            dragged = false;
            startX = theCanvas.canvasScale(mevt.getX());
            startY = theCanvas.canvasScale(mevt.getY());
            backupImage = theCanvas.getBufferedImage();
            curImage = theCanvas.getBufferedImage();
            g2D = curImage.createGraphics();
            theCanvas.setBufferedImage(curImage);    
        } else if (clicks == 2) {
            firstX = theCanvas.canvasScale(mevt.getX());
            firstY = theCanvas.canvasScale(mevt.getY());
            secondX = firstX;
            secondY = firstY;
            g2D.drawImage(backupImage,null,0,0);
            drawCurve(mevt,g2D,theCanvas);
            theCanvas.repaint();
        } else if (clicks == 3) {
            secondX = theCanvas.canvasScale(mevt.getX());
            secondY = theCanvas.canvasScale(mevt.getY());
            g2D.drawImage(backupImage,null,0,0);
            drawCurve(mevt,g2D,theCanvas);
            theCanvas.repaint();
        }
    }
    
    public void dragAction(MouseEvent mevt, main_canvas theCanvas) {
        dragged = true;
        if (clicks == 1) {
            g2D.drawImage(backupImage,null,0,0);
            drawLine(mevt,g2D,theCanvas);
            theCanvas.repaint();
        } else if (clicks == 2) {
            firstX = theCanvas.canvasScale(mevt.getX());
            firstY = theCanvas.canvasScale(mevt.getY());
            secondX = firstX;
            secondY = firstY;
            g2D.drawImage(backupImage,null,0,0);
            drawCurve(mevt,g2D,theCanvas);
            theCanvas.repaint();
        } else if (clicks == 3) {
            secondX = theCanvas.canvasScale(mevt.getX());
            secondY = theCanvas.canvasScale(mevt.getY());
            g2D.drawImage(backupImage,null,0,0);
            drawCurve(mevt,g2D,theCanvas);
            theCanvas.repaint();
        }
    }
    
    public void mouseReleaseAction(MouseEvent mevt, main_canvas theCanvas) {
        if (dragged) {
            dragged = false;
            if (clicks == 1) {
                g2D.drawImage(backupImage,null,0,0);
                lineEndX = theCanvas.canvasScale(mevt.getX());
                lineEndY = theCanvas.canvasScale(mevt.getY());
                drawLine(mevt,g2D,theCanvas);
                theCanvas.repaint();
                clicks = 2;
            } else if (clicks == 2) {
                g2D.drawImage(backupImage,null,0,0);
                firstX = theCanvas.canvasScale(mevt.getX());
                firstY = theCanvas.canvasScale(mevt.getY());
                secondX = firstX;
                secondY = firstY;
                drawCurve(mevt,g2D,theCanvas);
                theCanvas.repaint();
                clicks = 3;
            } else if (clicks == 3) {
                g2D.drawImage(backupImage,null,0,0);
                secondX = theCanvas.canvasScale(mevt.getX());
                secondY = theCanvas.canvasScale(mevt.getY());
                drawCurve(mevt,g2D,theCanvas);
                theCanvas.repaint();
                clicks = 1;
            }
        }
    }
       
    public void drawCurve(MouseEvent mevt, Graphics2D g2D, main_canvas theCanvas) {
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            g2D.setColor(theCanvas.left_color);
        } else {
            g2D.setColor(theCanvas.right_color);
        }
        g2D.setStroke(curveStroke);
        g2D.draw(new CubicCurve2D.Double(startX,startY,firstX,firstY,secondX,secondY,lineEndX,lineEndY));
    }
    
    public void drawLine(MouseEvent mevt, Graphics2D g2D, main_canvas theCanvas) {
        int endX, endY;
        
        endX = theCanvas.canvasScale(mevt.getX());
        endY = theCanvas.canvasScale(mevt.getY());
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            g2D.setColor(theCanvas.left_color); 
        } else {
            g2D.setColor(theCanvas.right_color);
        }
        g2D.setStroke(curveStroke);
        g2D.draw(new Line2D.Double(startX,startY,endX,endY));
    }
    
    public void setCurveStroke(int size) { curveStroke = new BasicStroke(size); }
    
    public void deSelect(main_canvas theCanvas) {
    	if (clicks != 1) {
    		g2D.setStroke(curveStroke);
        	g2D.draw(new CubicCurve2D.Double(startX,startY,firstX,firstY,secondX,secondY,lineEndX,lineEndY));
			clicks = 1;
			theCanvas.repaint(); 
		}
    }
    
}

/*
public class lineTool implements ourTool {
    private int startX, startY;
    private boolean dragged = false;
    private BufferedImage curImage, backupImage;
    private Stroke lineStroke;
    
    public lineTool() {
        super();
        lineStroke = new BasicStroke(1.f);
    }
    
    public void clickAction(MouseEvent mevt,main_canvas theCanvas) {
        dragged = false;
        startX = theCanvas.canvasScale(mevt.getX());
        startY = theCanvas.canvasScale(mevt.getY());
        System.out.println("Line");
        backupImage = theCanvas.getBufferedImage();
        curImage = theCanvas.getBufferedImage();
        theCanvas.setBufferedImage(curImage);
    }
    
    public void dragAction(MouseEvent mevt,main_canvas theCanvas) {
        dragged = true;
        curImage.createGraphics().drawImage(backupImage,null,0,0);
        drawLine(mevt,curImage.createGraphics(),theCanvas);
        theCanvas.repaint();
    }
    
    public void mouseReleaseAction(MouseEvent mevt,main_canvas theCanvas) {
        if (dragged) {
            curImage.createGraphics().drawImage(backupImage,null,0,0);
            drawLine(mevt,curImage.createGraphics(),theCanvas);
            theCanvas.repaint();
            dragged = false;
        }
    }

    public void drawLine(MouseEvent mevt, Graphics2D g2D, main_canvas theCanvas) {
        int endX, endY;
        
        endX = theCanvas.canvasScale(mevt.getX());
        endY = theCanvas.canvasScale(mevt.getY());
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            g2D.setColor(theCanvas.left_color); 
        } else {
            g2D.setColor(theCanvas.right_color);
        }
        g2D.setStroke(lineStroke);
        g2D.draw(new Line2D.Double(startX,startY,endX,endY));
    }
        
   public void setLineStroke(int size) {
       lineStroke = new BasicStroke(size);
   }
    
}*/