import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;

public class ellipseTool implements ourTool {
    private int startX, startY;
    private boolean dragged = false;
    private int fillType = 1;
        // 1 = border left_color, 2 = fill with right_color, 3 = solid left_color
    private BufferedImage curImage, backupImage;
    
    public void clickAction(MouseEvent mevt, main_canvas theCanvas) {
        dragged = false;
        startX = theCanvas.canvasScale(mevt.getX());
        startY = theCanvas.canvasScale(mevt.getY());
        //System.out.println("Ellipse--left mouse");
        backupImage = theCanvas.getBufferedImage();
        curImage = theCanvas.getBufferedImage();
        theCanvas.setBufferedImage(curImage);
    }
    
    public void dragAction(MouseEvent mevt, main_canvas theCanvas) { 
        dragged = true; 
        curImage.createGraphics().drawImage(backupImage,null,0,0);
        drawEllipse(mevt,curImage.createGraphics(),theCanvas);
        theCanvas.repaint();
    }
    
    public void mouseReleaseAction(MouseEvent mevt, main_canvas theCanvas) {
               
        if (dragged) {
            curImage.createGraphics().drawImage(backupImage,null,0,0);
            drawEllipse(mevt,curImage.createGraphics(),theCanvas);
            theCanvas.repaint();
            dragged = false;
            //System.out.println("Ellipse: "+x+","+y+","+width+","+height);
        }
    }
    
    public void setFillType(int theFillType) { fillType = theFillType; }
    
    public void drawEllipse(MouseEvent mevt, Graphics2D g2D, main_canvas theCanvas) {
        int endX, endY, x, y, width, height;
                
        endX = theCanvas.canvasScale(mevt.getX());
        endY = theCanvas.canvasScale(mevt.getY());
        x = startX;
        y = startY;
        if (endX < startX) {
            x = endX;
        }
        if (endY < startY) {
            y = endY;
        }
        width = Math.abs(startX - endX);
        height = Math.abs(startY - endY);
        if (fillType == 1) {
            if (SwingUtilities.isLeftMouseButton(mevt)) {
                g2D.setColor(theCanvas.left_color);
            } else {
                g2D.setColor(theCanvas.right_color);
            }
            g2D.draw(new Ellipse2D.Double(x,y,width,height));
        } else if (fillType == 2) {
            if (SwingUtilities.isLeftMouseButton(mevt)) {
                g2D.setColor(theCanvas.right_color);
            } else {
                g2D.setColor(theCanvas.left_color);
            }
            g2D.fill(new Ellipse2D.Double(x,y,width,height));
            if (SwingUtilities.isLeftMouseButton(mevt)) {
                g2D.setColor(theCanvas.left_color);
            } else {
                g2D.setColor(theCanvas.right_color);
            }
            g2D.draw(new Ellipse2D.Double(x,y,width,height));
        } else {
            if (SwingUtilities.isLeftMouseButton(mevt)) {
                g2D.setColor(theCanvas.left_color);
            } else {
                g2D.setColor(theCanvas.right_color);
            }
            g2D.fill(new Ellipse2D.Double(x,y,width,height));
        } 
    }
}
