import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;

public class eraserTool implements ourTool {
    Graphics2D g2D;
    BufferedImage eraseImage;
    private int eraserSize;
    
    public eraserTool() {
        super();
        eraserSize = 6;
    }
    
    public void clickAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y;
        
        eraseImage = theCanvas.getBufferedImage();
        theCanvas.setBufferedImage(eraseImage);
        g2D = eraseImage.createGraphics();
        x = theCanvas.canvasScale(mevt.getX());
        y = theCanvas.canvasScale(mevt.getY());
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            g2D.setColor(theCanvas.right_color);
        } else {
            g2D.setColor(theCanvas.left_color);
        }
        g2D.fill(getEraserShape(x,y));
    }
    
    public void dragAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y;
        
        x = theCanvas.canvasScale(mevt.getX());
        y = theCanvas.canvasScale(mevt.getY());
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            g2D.setColor(theCanvas.right_color);
        } else {
            g2D.setColor(theCanvas.left_color);
        }
        g2D.fill(getEraserShape(x,y));
        theCanvas.repaint();
    }
    
    public void mouseReleaseAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y;
        
        x = theCanvas.canvasScale(mevt.getX());
        y = theCanvas.canvasScale(mevt.getY());
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            g2D.setColor(theCanvas.right_color);
        } else {
            g2D.setColor(theCanvas.left_color);
        }
        g2D.fill(getEraserShape(x,y));
        theCanvas.repaint(); 
    }
       
    public Shape getEraserShape(int x, int y) {
        Rectangle eraser;
        Double theSize = new Double(eraserSize/2);
        eraser = new Rectangle(x-theSize.intValue(),y-theSize.intValue(),eraserSize,eraserSize);
        return eraser;
    }
    
    public void setEraserSize(int newSize) { eraserSize = newSize; }
}
