import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;


public class lineTool implements ourTool {
    private int startX, startY;
    private boolean dragged = false;
    private BufferedImage curImage, backupImage;
    private Stroke lineStroke;
    
    public lineTool() {
        super();
        lineStroke = new BasicStroke(1.f);
    }
    
    public void clickAction(MouseEvent mevt,main_canvas theCanvas) {
        dragged = false;
        startX = theCanvas.canvasScale(mevt.getX());
        startY = theCanvas.canvasScale(mevt.getY());
        System.out.println("Line");
        backupImage = theCanvas.getBufferedImage();
        curImage = theCanvas.getBufferedImage();
        theCanvas.setBufferedImage(curImage);
    }
    
    public void dragAction(MouseEvent mevt,main_canvas theCanvas) {
        dragged = true;
        curImage.createGraphics().drawImage(backupImage,null,0,0);
        drawLine(mevt,curImage.createGraphics(),theCanvas);
        theCanvas.repaint();
    }
    
    public void mouseReleaseAction(MouseEvent mevt,main_canvas theCanvas) {
        if (dragged) {
            curImage.createGraphics().drawImage(backupImage,null,0,0);
            drawLine(mevt,curImage.createGraphics(),theCanvas);
            theCanvas.repaint();
            dragged = false;
        }
    }

    public void drawLine(MouseEvent mevt, Graphics2D g2D, main_canvas theCanvas) {
        int endX, endY;
        
        endX = theCanvas.canvasScale(mevt.getX());
        endY = theCanvas.canvasScale(mevt.getY());
        if (SwingUtilities.isLeftMouseButton(mevt)) {
            g2D.setColor(theCanvas.left_color); 
        } else {
            g2D.setColor(theCanvas.right_color);
        }
        g2D.setStroke(lineStroke);
        g2D.draw(new Line2D.Double(startX,startY,endX,endY));
    }
        
   public void setLineStroke(int size) {
       lineStroke = new BasicStroke(size);
   }
    
}
