import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.awt.geom.*;

public class main_canvas extends JPanel {    
    public LinkedList list;
    private BufferedImage main_image = null;    
    public Color left_color;
    public Color right_color;
    public Stroke current_stroke;
    public Font current_font;
    private int place = 0;
    //Shape s = new Shape();
    public boolean line = false;
    public boolean curve = false;
    public boolean rounded_rectangle = false;
    public boolean square = false;
    public boolean polygon = false;
    public boolean elipse = false;
    public boolean selectall = false;
    public boolean eraser = false;    
    public boolean paint = false;  
    public boolean medicine = false;  
    public boolean zoom = false;  
    public boolean pencil = false;
    public boolean brush = false;  
    public boolean spray = false;  
    public boolean letter = false;          
    public boolean select = false;
    static double zoomFactor = 1.0;
    static double oldZoomFactor = 1.0;
    public JScrollPane pictureScrollPane = new JScrollPane();
    public ScrollablePicture picture;
    private ImageIcon main_icon = null;    
    
    public main_canvas() {
        // Start loading the image icon now.
        pictureScrollPane.setPreferredSize(new Dimension(200, 200));
        list = new LinkedList();
        clear();
        setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        add(pictureScrollPane);        
    }

    public void itemStateChanged(ItemEvent e) {            
        picture.setMaxUnitIncrement(1);
    }
    public boolean madeChanges() {
    	if(list.size() <=1)
    		return false;
    	return true;
    }
    public void clear(){
        System.out.println(list.size());
        if(place != 0){
            for(int i = 0; i < place; ++i){
                list.removeFirst();
            }
        }
        place = 0;
        if(list.size() == 4)
            list.remove(3);
        if(main_image != null){
        	main_image = new BufferedImage(main_image.getWidth(),main_image.getHeight(),BufferedImage.TYPE_INT_RGB);
    	}
    	else{
    		main_image = new BufferedImage(200,200,BufferedImage.TYPE_INT_RGB);
    	}
        Graphics2D g2d = main_image.createGraphics();
        g2d.setColor(Color.white);
        g2d.fillRect(0,0,main_image.getWidth(),main_image.getHeight());
        BufferedImage tempx = main_image.getSubimage(0,0,main_image.getWidth(), main_image.getHeight());
        list.add(tempx);
        //this.repaint();            
        System.out.println(list.size());        
    }

    public void setStroke(int in){
        current_stroke = new BasicStroke(in);
    }
    public void setFont(Font f){
        current_font = f;
    }
    public void drawIt(Shape s){
        if(place != 0){
            for(int i = 0; i < place; ++i){
                list.removeFirst();
            }
        }
        place = 0;
        if(list.size() == 4)
            list.remove(3);
        Graphics2D g2D = this.main_image.createGraphics();
        g2D.draw(s);
        BufferedImage tempx = main_image.getSubimage(0,0,main_image.getWidth(), main_image.getHeight());
        list.add(0,tempx);
        //repaint();
    }
    public void resizeImage(int width, int height){
        if(place != 0){
            for(int i = 0; i < place; ++i){
                list.removeFirst();
            }
        }
        place = 0;
        if(list.size() == 4)
            list.remove(3);
        System.out.println("Resizing image");
        BufferedImage temp = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
        Graphics2D helper = temp.createGraphics();        
        //helper.
        helper.setColor(Color.white);
        helper.fillRect(0,0,width, height);
        helper.drawImage(main_image,null,0,0);
        main_image = getCopy(temp);
        list.add(0,temp);
        //repaint();
    }
    public void setBufferedImage(BufferedImage in) {
        if(place != 0){
            for(int i = 0; i < place; ++i){
                list.removeFirst();
            }
        }
        place = 0;
         if(list.size() == 4)
            list.remove(3);
           main_image = in;
         list.add(0,main_image);
         repaint();
    }
    public BufferedImage getBufferedImage(){
        //repaint();
        return getCopy(main_image);
    }
    public BufferedImage getCopy(BufferedImage in){
       BufferedImage temp = new BufferedImage(in.getWidth(), in.getHeight(),BufferedImage.TYPE_INT_RGB);
       Graphics2D g2d = temp.createGraphics();
       g2d.drawImage(in,null,0,0);
       return temp;
    }
    public void setLeftColor(Color in){
        left_color = in;
    }
    public void setRightColor(Color in) {
        right_color = in;
    }
    
    //***************************BEGINNING OF PAINT METHOD
    public void paint(Graphics g) {        
       if (main_image != null)
        {   
        	Graphics2D g2d = (Graphics2D)g;
            AffineTransform t = new AffineTransform();
          	t.setToScale(zoomFactor,zoomFactor);
            BufferedImage temp = new BufferedImage((int)(main_image.getWidth()*zoomFactor), 
            									   (int)(main_image.getHeight()*zoomFactor), BufferedImage.TYPE_INT_RGB);
            Graphics2D gd = temp.createGraphics();
            gd.drawImage(main_image,t,null);
                        
            g2d.drawImage((Image)temp,0,0,temp.getWidth(),temp.getHeight(),null);
            main_icon = new ImageIcon((Image)temp);
            
            picture = new ScrollablePicture(main_icon, 1);            
            
            int oldX = (int)pictureScrollPane.getViewport().getViewPosition().getX();
            int oldY = (int)pictureScrollPane.getViewport().getViewPosition().getY();
            Point old = new Point(oldX,oldY);
            pictureScrollPane.setViewportView(picture);
            pictureScrollPane.getViewport().setViewPosition(old);            
            pictureScrollPane.paintAll(g2d);                      
       }        
    }
    //***************************END OF PAINT METHOD
    
    public void undo(){
        System.out.println("UNDO" + list.size() + " " + place);
        if(place+1 <=list.size()-1){
            ++place;
            main_image = (BufferedImage)list.get(place);
        }
        //repaint();
    }
    public void redo(){
        System.out.println("REDO" + list.size() + " " + place);
        if(place >0){
            --place;
            main_image = (BufferedImage)list.get(place);
        }
        //repaint();
    }
    
    public int canvasScale(int coord) { return coord; }
    
    public void setZoom(double factor){
        zoomFactor = factor;
    }
    public void setOldZoom(double factor){
        oldZoomFactor = factor;
    }
    public double getZoom(){
        return(zoomFactor);
    }
    public double getOldZoom(){
        return(oldZoomFactor);
    }    
    
    //beginning of invertColors()
    public void invertColors(){

        int w = main_image.getWidth();
        int h = main_image.getHeight();
        int x = main_image.getMinX();
        int y = main_image.getMinY();
        
        int[] pixels = new int[w * h];
        PixelGrabber pg = new PixelGrabber((Image)main_image, x, y, w, h, pixels, 0, w);
        try 
        {
            pg.grabPixels();
        } catch (InterruptedException e) 
        {
            System.err.println("interrupted waiting for pixels!");
            return;
        }

        int[] rgbArray = new int[w * h];
        for (int j = 0; j < h; j++) 
        {
            for (int i = 0; i < w; i++) 
            {                
                int pixel = pixels[j * w + i];
                //int alpha = (pixel >> 24) & 0xff;
                int red = (pixel >> 16) & 0xff;
                int green = (pixel >> 8) & 0xff;
                int blue = (pixel ) & 0xff;
                
                red = Math.abs((red - 255));
                green = Math.abs((green - 255));                
                blue = Math.abs((blue - 255));
                Color newColor = new Color(red,green,blue);
                
                main_image.setRGB(x+i,y+j,newColor.getRGB());
            }
        }        
        //repaint();
    }
    //end of invertColors()
        
    public static void main(String s[]) {
        JFrame frame = new JFrame("ScrollDemo");
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
 
        frame.setContentPane(new main_canvas());
        frame.pack();
        frame.setVisible(true);
    }
}
