import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.geom.*;
import java.awt.image.*;

public class polygonTool implements ourTool {
    int lastX, lastY, curX, curY;
    Graphics2D polyG2D;
    BufferedImage polyImage = new BufferedImage(200,200,BufferedImage.TYPE_INT_RGB);
    BufferedImage backupImage = new BufferedImage(200,200,BufferedImage.TYPE_INT_RGB);
    boolean dragged = false;
    Polygon curPolygon;
    private int fillType = 1;
    
    polygonTool() { super(); }
    
    public void clickAction(MouseEvent evt, main_canvas theCanvas) {
        if (evt.getClickCount() < 2) {
        	if (!(dragged)) {
                lastX = theCanvas.canvasScale(evt.getX());
                lastY = theCanvas.canvasScale(evt.getY());
                curPolygon = new Polygon();
                curPolygon.addPoint(lastX,lastY);
                polyImage = theCanvas.getBufferedImage();
                polyG2D = polyImage.createGraphics();
                theCanvas.setBufferedImage(polyImage);
            } 
            backupImage = theCanvas.getCopy(polyImage);
            	
        } else {
            if (dragged) {
                curX = theCanvas.canvasScale(evt.getX());
                curY = theCanvas.canvasScale(evt.getY());
                curPolygon.addPoint(curX,curY);
                dragged = false;
                if (SwingUtilities.isLeftMouseButton(evt)) {
                	polyG2D.setColor(theCanvas.left_color);
                } else {
                	polyG2D.setColor(theCanvas.right_color);
                }
                if (fillType == 1) {
                    polyG2D.draw(curPolygon);
                   // theCanvas.setBufferedImage(polyImage);
                } else if (fillType == 2) {
                	if (SwingUtilities.isLeftMouseButton(evt)) {
                		polyG2D.setColor(theCanvas.right_color);
                    	polyG2D.fill(curPolygon);
                    	polyG2D.setColor(theCanvas.left_color);
                    	polyG2D.draw(curPolygon);
                    	//theCanvas.setBufferedImage(polyImage);
                	} else {
                		polyG2D.setColor(theCanvas.left_color);
                    	polyG2D.fill(curPolygon);
                    	polyG2D.setColor(theCanvas.right_color);
                    	polyG2D.draw(curPolygon);
                    	//theCanvas.setBufferedImage(polyImage);
                	}
                    
                } else {
                    polyG2D.fill(curPolygon);
                    //theCanvas.setBufferedImage(polyImage);
                }
            }
            theCanvas.repaint();
        }
    }
    
    public void dragAction(MouseEvent evt, main_canvas theCanvas) {
        dragged = true;
        polyG2D.drawImage(backupImage,null,0,0);
        if (SwingUtilities.isLeftMouseButton(evt)) {
        	polyG2D.setColor(theCanvas.left_color);
        } else {
        	polyG2D.setColor(theCanvas.right_color);
        }
       	polyG2D.drawLine(lastX,lastY,evt.getX(),evt.getY());
       	theCanvas.repaint();
    }
    
    public void mouseReleaseAction(MouseEvent evt, main_canvas theCanvas) {
    	polyG2D.drawImage(backupImage,null,0,0);
        if (dragged) {
            curX = theCanvas.canvasScale(evt.getX());
            curY = theCanvas.canvasScale(evt.getY());
            curPolygon.addPoint(curX,curY);
            if (SwingUtilities.isLeftMouseButton(evt)) {
            	polyG2D.setColor(theCanvas.left_color);
            } else {
            	polyG2D.setColor(theCanvas.right_color);
            }
            polyG2D.draw(new Line2D.Double(lastX,lastY,curX,curY));
            theCanvas.repaint();
            lastX = curX;
            lastY = curY;
        }
    }
 
    public void setFillType(int theFillType) { fillType = theFillType; }
    
    public void deSelect(main_canvas theCanvas) {
    	if (dragged == true) {
    		if (fillType == 1) {
                polyG2D.draw(curPolygon);
                // theCanvas.setBufferedImage(polyImage);
            } else if (fillType == 2) {
            	if (polyG2D.getColor() == theCanvas.left_color) {
              		polyG2D.setColor(theCanvas.right_color);
               		polyG2D.fill(curPolygon);
               		polyG2D.setColor(theCanvas.left_color);
               		polyG2D.draw(curPolygon);
               		//theCanvas.setBufferedImage(polyImage);
               	} else {
               		polyG2D.setColor(theCanvas.left_color);
               		polyG2D.fill(curPolygon);
               		polyG2D.setColor(theCanvas.right_color);
               		polyG2D.draw(curPolygon);
               	}
            } else {
            	polyG2D.fill(curPolygon);
            }
            theCanvas.repaint();
            dragged = false;
        }
    }
}