import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;

public class rectTool implements ourTool {
    private int startX, startY;
    private boolean dragged = false;
    private int fillType = 1;
        // 1 = border left_color, 2 = fill with right_color, 3 = solid left_color
    BufferedImage curImage, backupImage;
    Graphics2D g2D;
    
    public void clickAction(MouseEvent mevt, main_canvas theCanvas) {
        dragged = false;
        startX = mevt.getX();
        startY = mevt.getY();
        //System.out.println("Rectangle--left mouse");
        backupImage = theCanvas.getBufferedImage();
        curImage = theCanvas.getBufferedImage();
        theCanvas.setBufferedImage(curImage);
        g2D = curImage.createGraphics();
        theCanvas.repaint();
    }
    
    public void dragAction(MouseEvent mevt, main_canvas theCanvas) { 
        int endX, endY, x, y, width, height;
        
        g2D.drawImage(backupImage,null,0,0);
        dragged = true; 
        endX = mevt.getX();
        endY = mevt.getY();
        x = startX;
        y = startY;
        if (endX < startX) {
           x = endX;
        }
        if (endY < startY) {
           y = endY;
        }
        width = Math.abs(startX - endX);
        height = Math.abs(startY - endY);
        drawRectangle(x,y,width,height,mevt,g2D,theCanvas);
        theCanvas.repaint();
    }
    
    public void mouseReleaseAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y, width, height, endX, endY;
        
        
        if (dragged) {
            g2D.drawImage(backupImage,null,0,0);
            endX = mevt.getX();
            endY = mevt.getY();
            x = startX;
            y = startY;
            if (endX < startX) {
                x = endX;
            }
            if (endY < startY) {
                y = endY;
            }
            width = Math.abs(startX - endX);
            height = Math.abs(startY - endY);
            drawRectangle(x,y,width,height,mevt,g2D,theCanvas);
            theCanvas.repaint(); 
            dragged = false;
            //System.out.println("Drew rectangle: "+x+","+y+","+width+","+height);
        }
    }
    
    public void setFillType(int theFillType) { fillType = theFillType; }
    
     public void drawRectangle(int x, int y, int width, int height, MouseEvent mevt,Graphics2D g2D,main_canvas theCanvas) {
        if (fillType == 1) {
                if (SwingUtilities.isLeftMouseButton(mevt)) {
                    g2D.setColor(theCanvas.left_color);
                } else {
                    g2D.setColor(theCanvas.right_color);
                }
                g2D.draw(new Rectangle(x,y,width,height));
            } else if (fillType == 2) {
                if (SwingUtilities.isLeftMouseButton(mevt)) {
                    g2D.setColor(theCanvas.right_color);
                } else {
                    g2D.setColor(theCanvas.left_color);
                }
                g2D.fill(new Rectangle(x,y,width,height));
                if (SwingUtilities.isLeftMouseButton(mevt)) {
                    g2D.setColor(theCanvas.left_color);
                } else {
                    g2D.setColor(theCanvas.right_color);
                }
                g2D.draw(new Rectangle(x,y,width,height));
            } else {
                if (SwingUtilities.isLeftMouseButton(mevt)) {
                    g2D.setColor(theCanvas.left_color);
                } else {
                    g2D.setColor(theCanvas.right_color);
                }
                g2D.fill(new Rectangle(x,y,width,height));
            } 
     }

}