import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;

public class roundedRectTool implements ourTool {
    private int startX, startY;
    private boolean dragged = false;
    private int fillType = 1;
    final int arc_length = 10;
    final int arc_height = 10;
        // 1 = border left_color, 2 = fill with right_color, 3 = solid left_color
    private BufferedImage curImage, backupImage;
    
    public void clickAction(MouseEvent mevt, main_canvas theCanvas) {
        dragged = false;
        startX = theCanvas.canvasScale(mevt.getX());
        startY = theCanvas.canvasScale(mevt.getY());
        backupImage = theCanvas.getBufferedImage();
        curImage = theCanvas.getBufferedImage();
        theCanvas.setBufferedImage(curImage);
    }
    
    public void dragAction(MouseEvent mevt, main_canvas theCanvas) { 
        int x, y, width, height, endX, endY;
        
        dragged = true; 
        curImage.createGraphics().drawImage(backupImage,null,0,0);
        endX = theCanvas.canvasScale(mevt.getX());
        endY = theCanvas.canvasScale(mevt.getY());
        x = startX;
        y = startY;
        if (endX < startX) {
            x = endX;
        }
        if (endY < startY) {
            y = endY;
        }
        width = Math.abs(startX - endX);
        height = Math.abs(startY - endY);
        drawRoundRect(x,y,width,height,mevt,curImage.createGraphics(),theCanvas);
        theCanvas.repaint();
    }
    
    public void mouseReleaseAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y, width, height, endX, endY;
                
        if (dragged) {
            curImage.createGraphics().drawImage(backupImage,null,0,0);
            endX = theCanvas.canvasScale(mevt.getX());
            endY = theCanvas.canvasScale(mevt.getY());
            x = startX;
            y = startY;
            if (endX < startX) {
                x = endX;
            }
            if (endY < startY) {
                y = endY;
            }
            width = Math.abs(startX - endX);
            height = Math.abs(startY - endY);
            drawRoundRect(x,y,width,height,mevt,curImage.createGraphics(),theCanvas);
            dragged = false;
        }
    }
    
    public void setFillType(int theFillType) { fillType = theFillType; }
    
    public void drawRoundRect(int x, int y,int width, int height, MouseEvent mevt, Graphics2D g2D,main_canvas theCanvas) {
        RoundRectangle2D rect2D; 
        
        if (fillType == 1) {
            if (SwingUtilities.isLeftMouseButton(mevt)) {
                g2D.setColor(theCanvas.left_color);
            } else {
                g2D.setColor(theCanvas.right_color);
            }
            rect2D = new RoundRectangle2D.Double(x,y,width,height,arc_length,arc_height);
            g2D.draw(rect2D);
         } else if (fillType == 2) {
             if (SwingUtilities.isLeftMouseButton(mevt)) {
                g2D.setColor(theCanvas.right_color);
             } else {
                 g2D.setColor(theCanvas.left_color);
             }
             rect2D = new RoundRectangle2D.Double(x,y,width,height,arc_length,arc_height);
             g2D.fill(rect2D);
             if (SwingUtilities.isLeftMouseButton(mevt)) {
                g2D.setColor(theCanvas.left_color);
             } else {
                 g2D.setColor(theCanvas.right_color);
             }
             rect2D = new RoundRectangle2D.Double(x,y,width,height,arc_length,arc_height);
             g2D.draw(rect2D);
         } else {
             if (SwingUtilities.isLeftMouseButton(mevt)) {
                g2D.setColor(theCanvas.left_color);
             } else {
                 g2D.setColor(theCanvas.right_color);
             }
             rect2D = new RoundRectangle2D.Double(x,y,width,height,arc_length,arc_height);
             g2D.fill(rect2D);
         }                
    }
}
