import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;

public class selectTool implements ourTool {

    public selectTool() {
        super();
        selectStroke = new BasicStroke(1.f,BasicStroke.CAP_BUTT,BasicStroke.JOIN_BEVEL,8.f,new float[]{6.f,6.f},0.f);
    }
    
    private int startX, startY, endX, endY;
    private int curX, curY;
    private boolean dragged = false;
    private boolean moved = false;
    private int fillType = 1;
        // 1 = border left_color, 2 = fill with right_color, 3 = solid left_color
    BufferedImage curImage, backupImage, selectedImage, pastedImage;
    Graphics2D g2D;
    private boolean selected = false;
    private boolean pasted = false;
    private boolean moving = false;
    private BasicStroke selectStroke;
    private int pasteX, pasteY;
    private Polygon cursorPolygon;
    private boolean drawOpaque = true;
       
    public void clickAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y;
        int temp;
        
        Rectangle boundRect;
        if (pasted == false) {
            dragged = false;
            if (selected == true) {
                x = theCanvas.canvasScale(mevt.getX());
                y = theCanvas.canvasScale(mevt.getY());
                /*if (endX < startX) {
                    temp = endX;
                    endX = startX;
                    startX = temp;
                }
                if (endY < startY) {
                    temp = endY;
                    endY = startY;
                    startY = temp;
                }*/
                //boundRect = new Rectangle(startX,startY,Math.abs(startX-endX),Math.abs(startY-endY));
                boundRect = cursorPolygon.getBounds();
                if (boundRect.contains(x,y)) {
                    g2D.drawImage(backupImage,null,0,0);
                    pasted = true;
                    selected = true;
                    curX = x;
                    curY = y;
                    //pastedImage = selectedImage;
                    //g2D.setColor(theCanvas.right_color);
                    //g2D.fill(boundRect);
                    backupImage = theCanvas.getBufferedImage();
                    curImage = theCanvas.getBufferedImage();
                    cutBackground(backupImage,theCanvas.right_color);
                    cutBackground(curImage,theCanvas.right_color);
                    g2D = curImage.createGraphics();
                    myDrawImage(theCanvas.right_color);
                    theCanvas.setBufferedImage(curImage);
                } else {    
                    g2D.drawImage(backupImage,null,0,0);
                    myDrawImage(theCanvas.right_color);
                    selected = false;
                    pasted = false;
                    moved = false;
                    theCanvas.repaint();
                }
            } else {
                backupImage = theCanvas.getBufferedImage();
                curImage = theCanvas.getBufferedImage();
                theCanvas.setBufferedImage(curImage);
                g2D = curImage.createGraphics();
            }
            cursorPolygon = new Polygon();
            startX = theCanvas.canvasScale(mevt.getX());
            startY = theCanvas.canvasScale(mevt.getY());
            cursorPolygon.addPoint(startX,startY);
            theCanvas.repaint();
        } else {
            x = theCanvas.canvasScale(mevt.getX());
            y = theCanvas.canvasScale(mevt.getY());
            boundRect = new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight());
            if (!(boundRect.contains(x,y))) {
                pasted = false;
                selected = false;
                g2D.drawImage(backupImage,null,0,0);
                myDrawImage(theCanvas.right_color);
                theCanvas.repaint();
                //g2D.drawImage(pastedImage,null,pasteX,pasteY);
            } else {
                moved = true;
                curX = x;
                curY = y;
            }
        }
    }
    
    public void dragAction(MouseEvent mevt, main_canvas theCanvas) { 
        int x, y, width, height;
        
        
        if ((pasted == false) && (moved == false)) {
            g2D.drawImage(backupImage,null,0,0);
            dragged = true; 
            x = theCanvas.canvasScale(mevt.getX());
            y = theCanvas.canvasScale(mevt.getY());
            cursorPolygon.addPoint(x,y);            
            g2D.setColor(Color.black);
            g2D.setStroke(selectStroke);
            g2D.draw(cursorPolygon);
            theCanvas.repaint();
        } else {
            Double aDouble;
            g2D.drawImage(backupImage,null,0,0);
            x = theCanvas.canvasScale(mevt.getX());
            y = theCanvas.canvasScale(mevt.getY());
            //aDouble = new Double(x - (pastedImage.getWidth()/2));
            //pasteX =  aDouble.intValue();
            //aDouble = new Double(y - (pastedImage.getHeight()/2));
            //pasteY = aDouble.intValue();
            pasteX = pasteX + (x - curX);
            pasteY = pasteY + (y - curY);
            cursorPolygon.translate(x-curX,y-curY);
            myDrawImage(theCanvas.right_color);
            curX = x;
            curY = y;
            //g2D.drawImage(pastedImage,null,pasteX,pasteY);
            g2D.setColor(Color.black);
            g2D.setStroke(selectStroke);
            g2D.draw(new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight()));
            theCanvas.repaint();
           
        }
    
    }
    
    public void mouseReleaseAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y, width, height;
        Double xDub, yDub, widthDub, heightDub;
        
        if ((pasted == false) && (selected == false)){
            moved = false;
            if (dragged) {
                g2D.drawImage(backupImage,null,0,0);
                x = theCanvas.canvasScale(mevt.getX());
                y = theCanvas.canvasScale(mevt.getY());
                cursorPolygon.addPoint(x,y);
                Rectangle theBounds = cursorPolygon.getBounds();
                xDub = new Double(theBounds.getX());
                yDub = new Double(theBounds.getY());
                widthDub = new Double(theBounds.getWidth());
                heightDub = new Double(theBounds.getHeight());
                selectedImage = theCanvas.getCopy(curImage).getSubimage(xDub.intValue(),yDub.intValue(),widthDub.intValue(),heightDub.intValue());
                pastedImage = selectedImage;
                g2D.setColor(Color.black);
                g2D.setStroke(selectStroke);
                g2D.draw(theBounds);
                theCanvas.repaint(); 
                dragged = false;
                selected = true;
                startX = xDub.intValue();
                startY = yDub.intValue();
                pasteX = startX;
                pasteY = startY;
                endX = xDub.intValue() + widthDub.intValue();
                endY = yDub.intValue() + heightDub.intValue();
            }
        } else {
            Double aDouble;
            g2D.drawImage(backupImage,null,0,0);
            x = theCanvas.canvasScale(mevt.getX());
            y = theCanvas.canvasScale(mevt.getY());
            /*aDouble = new Double(x - (pastedImage.getWidth()/2));
            pasteX =  aDouble.intValue();
            aDouble = new Double(y - (pastedImage.getHeight()/2));
            pasteY = aDouble.intValue();*/
            pasteX = pasteX + (x - curX);
            pasteY = pasteY + (y - curY);
            cursorPolygon.translate(x-curX,y-curY);
            myDrawImage(theCanvas.right_color);
            curX = x;
            curY = y;
            //g2D.drawImage(pastedImage,null,pasteX,pasteY);
            g2D.setColor(Color.black);
            g2D.setStroke(selectStroke);
            g2D.draw(new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight()));
            theCanvas.repaint();
        }
    }
    
    public BufferedImage getCopyImage(main_canvas theCanvas) { 
        if ((pasted == true) || (selected == true)){
            g2D.drawImage(backupImage,null,0,0);
            myDrawImage(theCanvas.right_color);
            //g2D.drawImage(pastedImage,null,pasteX,pasteY);
            g2D.setColor(Color.black);
            g2D.setStroke(selectStroke);
            g2D.draw(new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight()));
            theCanvas.repaint();
            return pastedImage;
        }
        /*if (selected == true) {
            g2D.drawImage(backupImage,null,0,0);
            return selectedImage; 
        }*/ else {
            return new BufferedImage(10,10,BufferedImage.TYPE_INT_RGB);
        }
    }
    
    public BufferedImage getCutImage(main_canvas theCanvas) {
        int temp;
        if (pasted == true) {
            g2D.drawImage(backupImage,null,0,0);
            //g2D.setColor(theCanvas.right_color);
            //g2D.fill(new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight()));
            backupImage = theCanvas.getBufferedImage();
            curImage = theCanvas.getBufferedImage();
            g2D = curImage.createGraphics();
            theCanvas.setBufferedImage(curImage);
            theCanvas.repaint();
            pasted = false;
            selected = false;
            moved = false;
            return pastedImage;
        }
        if (selected == true) {
            g2D.drawImage(backupImage,null,0,0);
            if (endX < startX) {
                temp = endX;
                endX = startX;
                startX = temp;
            }
            if (endY < startY) {
                temp = endY;
                endY = startY;
                startY = temp;
            }
            //g2D.setColor(theCanvas.right_color);
            //g2D.fill(new Rectangle(startX,startY,Math.abs(startX-endX),Math.abs(startY-endY)));
            backupImage = theCanvas.getBufferedImage();
            curImage = theCanvas.getBufferedImage();
            cutBackground(backupImage,theCanvas.right_color);
            cutBackground(curImage,theCanvas.right_color);
            g2D = curImage.createGraphics();
            theCanvas.setBufferedImage(curImage);
            theCanvas.repaint();
            pasted = false;
            selected = false;
            moved = false;
            return selectedImage;
        } else {
            return new BufferedImage(10,10,BufferedImage.TYPE_INT_RGB);
        }
    }
    
    public void setPastedImage(BufferedImage theImage, main_canvas theCanvas) {
        int temp;
        
        if (pasted == true) {
            g2D.drawImage(backupImage,null,0,0);
            g2D.drawImage(selectedImage,null,pasteX,pasteY);
        } else if (selected == true){
            g2D.drawImage(backupImage,null,0,0);
        }
        pastedImage = theImage;
        curImage = theCanvas.getBufferedImage();
        backupImage = theCanvas.getBufferedImage();
        g2D = curImage.createGraphics();
        g2D.drawImage(pastedImage,null,0,0);
        pasteX = 0;
        pasteY = 0;
        g2D.setColor(Color.black);
        g2D.setStroke(selectStroke);
        g2D.draw(new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight()));
        theCanvas.setBufferedImage(curImage);
        pasted = true;
        selected = true;
        theCanvas.repaint();
    }
    
    public void deSelect(main_canvas theCanvas) {
    	if(backupImage!= null){
    		g2D.drawImage(backupImage,null,0,0);
    		myDrawImage(theCanvas.right_color);
    	}
    	//g2D.drawImage(pastedImage,null,pasteX,pasteY);
    	
    	selected = false;
    	moved = false;
    	pasted = false;
    	theCanvas.repaint();
    }
    
    public void setOpaque(boolean value) { drawOpaque = value; }
    
    public void clear(main_canvas theCanvas) {
    	if (selected = true) {
    		//g2D.setColor(theCanvas.right_color);
    		//g2D.fill(new Rectangle(pasteX,pasteY,pasteX+selectedImage.getWidth(),pasteY+selectedImage.getHeight()));
    		g2D.drawImage(backupImage,null,0,0);
    		cutBackground(curImage,theCanvas.right_color);
    		selected = false;
    		moved = false;
    		pasted = false;
    	} else if (pasted == true) {
    		g2D.drawImage(backupImage,null,0,0);
    		selected = false;
    		moved = false;
    		pasted = false;
    	}
    	theCanvas.repaint();
    }
    
    public void myDrawImage(Color rightColor) {
    	if (drawOpaque == true) {
    		System.out.println("("+cursorPolygon.getBounds().getX()+","+cursorPolygon.getBounds().getY()+")");
    		for (int count1X = 0;count1X < pastedImage.getWidth();count1X++) {
    			for (int count1Y = 0;count1Y < pastedImage.getHeight(); count1Y++) {
    				try {
    					if (cursorPolygon.contains(pasteX+count1X,pasteY+count1Y)) {
    						int theX = pasteX+count1X;
    						int theY = pasteY+count1Y;
    						System.out.println("Polygon contains ("+theX+","+theY+")");
    						curImage.setRGB(pasteX+count1X,pasteY+count1Y,pastedImage.getRGB(count1X,count1Y));
    					}
    				} catch(Exception e) { System.out.println("Exception in opaque"); }
    			}
    		}
    	} else {
    		System.out.println("("+cursorPolygon.getBounds().getX()+","+cursorPolygon.getBounds().getY()+")");
    		for (int countX = 0;countX < pastedImage.getWidth(); countX++) {
    			for (int countY = 0;countY < pastedImage.getHeight();countY++) {
    				try {
    					if ((cursorPolygon.contains(pasteX+countX,pasteY+countY)) && (pastedImage.getRGB(countX,countY) != rightColor.getRGB())) {
    						curImage.setRGB(pasteX+countX,pasteY+countY,pastedImage.getRGB(countX,countY));
    					}
    				} catch(Exception e) { System.out.println("Exception in not-opaque"); }
    			}
    		}
    	}
    }
    
    public void cutBackground(BufferedImage cuttingImg,Color rightColor) {
    	for (int countX = 0;countX < pastedImage.getWidth();countX++) {
    		for (int countY = 0; countY < pastedImage.getHeight();countY++) {
    			try {
    				if (cursorPolygon.contains(pasteX+countX,pasteY+countY)) {
    					cuttingImg.setRGB(pasteX+countX,pasteY+countY,rightColor.getRGB());
    				}
    			} catch(Exception e) {}
    		}
    	}
    }
}
