import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;

public class selectallTool implements ourTool {
    private int startX, startY, endX, endY;
    private boolean dragged = false;
    private boolean moved = false;
    private int fillType = 1;
        // 1 = border left_color, 2 = fill with right_color, 3 = solid left_color
    BufferedImage curImage, backupImage, selectedImage, pastedImage;
    Graphics2D g2D;
    private boolean selected = false;
    private boolean pasted = false;
    private boolean moving = false;
    private BasicStroke selectStroke;
    private int pasteX, pasteY;
    public boolean drawOpaque = true;
    public int onCanvasFlag = 0;
    
    public selectallTool() {
        super();
        selectStroke = new BasicStroke(1.f,BasicStroke.CAP_BUTT,BasicStroke.JOIN_BEVEL,8.f,new float[]{6.f,6.f},0.f);
    }
    
    public void clickAction(MouseEvent mevt, main_canvas theCanvas) {
    	       	
        int x, y;
        int temp;
        
        Rectangle boundRect;
        if (pasted == false) {
            dragged = false;
            if (selected == true && onCanvasFlag == 1) {
                x = theCanvas.canvasScale(mevt.getX());
                y = theCanvas.canvasScale(mevt.getY());
                if (endX < startX) {
                    temp = endX;
                    endX = startX;
                    startX = temp;
                }
                if (endY < startY) {
                    temp = endY;
                    endY = startY;
                    startY = temp;
                }
                boundRect = new Rectangle(startX,startY,Math.abs(startX-endX),Math.abs(startY-endY));
                if (boundRect.contains(x,y)) {
                    g2D.drawImage(backupImage,null,0,0);
                    pasted = true;
                    selected = true;
                    pasteX = startX;
                    pasteY = startY;
                    pastedImage = selectedImage;
                    g2D.setColor(theCanvas.right_color);
                    g2D.fill(boundRect);
                    backupImage = theCanvas.getBufferedImage();
                    curImage = theCanvas.getBufferedImage();
                    g2D = curImage.createGraphics();
                    theCanvas.setBufferedImage(curImage);
                } else {    
                    g2D.drawImage(backupImage,null,0,0);
                    selected = false;
                }
            } else {
                backupImage = theCanvas.getBufferedImage();
                curImage = theCanvas.getBufferedImage();
                theCanvas.setBufferedImage(curImage);
                g2D = curImage.createGraphics();
            }
            startX = theCanvas.canvasScale(mevt.getX());
            startY = theCanvas.canvasScale(mevt.getY());
            theCanvas.repaint();
        } else {
            x = theCanvas.canvasScale(mevt.getX());
            y = theCanvas.canvasScale(mevt.getY());
            boundRect = new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight());
            if (!(boundRect.contains(x,y))) {
                pasted = false;
                selected = false;
                g2D.drawImage(backupImage,null,0,0);
                //g2D.drawImage(pastedImage,null,pasteX,pasteY);
                myDrawImage(theCanvas.right_color);
            } else {
                moved = true;
            }
            theCanvas.repaint();
        }
    }
    
    public void dragAction(MouseEvent mevt, main_canvas theCanvas) { 
        int x, y, width, height;
        
        
        if ((pasted == false) && (moved == false)) {
            g2D.drawImage(backupImage,null,0,0);
            dragged = true; 
            endX = mevt.getX();
            endY = mevt.getY();
            x = startX;
            y = startY;
            if (endX < startX) {
                x = endX;
            }
            if (endY < startY) {
                y = endY;
            }
            width = Math.abs(startX - endX);
            height = Math.abs(startY - endY);
            g2D.setColor(Color.black);
            g2D.setStroke(selectStroke);
            g2D.draw(new Rectangle(x,y,width,height));
            theCanvas.repaint();
        } else {
            Double aDouble;
            g2D.drawImage(backupImage,null,0,0);
            x = theCanvas.canvasScale(mevt.getX());
            y = theCanvas.canvasScale(mevt.getY());
            aDouble = new Double(x - (pastedImage.getWidth()/2));
            pasteX =  aDouble.intValue();
            aDouble = new Double(y - (pastedImage.getHeight()/2));
            pasteY = aDouble.intValue();
            //g2D.drawImage(pastedImage,null,pasteX,pasteY);
            myDrawImage(theCanvas.right_color);
            g2D.setColor(Color.black);
            g2D.setStroke(selectStroke);
            g2D.draw(new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight()));
            theCanvas.repaint();
        }
    
    }
    
    public void mouseReleaseAction(MouseEvent mevt, main_canvas theCanvas) {
        int x, y, width, height;
        
        if (pasted == false) {
            moved = false;
            if (dragged) {
                g2D.drawImage(backupImage,null,0,0);
                endX = mevt.getX();
                endY = mevt.getY();
                x = startX;
                y = startY;
                if (endX < startX) {
                    x = endX;
                }
                if (endY < startY) {
                    y = endY;
                }
                width = Math.abs(startX - endX);
                height = Math.abs(startY - endY);
                selectedImage = theCanvas.getCopy(curImage).getSubimage(x,y,width,height);
                pastedImage = selectedImage;
                g2D.setColor(Color.black);
                g2D.setStroke(selectStroke);
                g2D.draw(new Rectangle(x,y,width,height));
                pasteX = startX;
                pasteY = startY;
                theCanvas.repaint(); 
                dragged = false;
                selected = true;
            }
        } else {        	
            Double aDouble;
            g2D.drawImage(backupImage,null,0,0);
            x = theCanvas.canvasScale(mevt.getX());
            y = theCanvas.canvasScale(mevt.getY());
            aDouble = new Double(x - (pastedImage.getWidth()/2));
            pasteX =  aDouble.intValue();
            aDouble = new Double(y - (pastedImage.getHeight()/2));
            pasteY = aDouble.intValue();
            //g2D.drawImage(pastedImage,null,pasteX,pasteY);
            myDrawImage(theCanvas.right_color);
            g2D.setColor(Color.black);
            g2D.setStroke(selectStroke);
            g2D.draw(new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight()));
            theCanvas.repaint();
        }
    }
    
    public BufferedImage getCopyImage(main_canvas theCanvas) { 
        if ((pasted == true) || (selected == true)){
            g2D.drawImage(backupImage,null,0,0);
            //g2D.drawImage(pastedImage,null,pasteX,pasteY);
            myDrawImage(theCanvas.right_color);
            g2D.setColor(Color.black);
            g2D.setStroke(selectStroke);
            g2D.draw(new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight()));
            theCanvas.repaint();
            return pastedImage;
        }/*
        if (selected == true) {
            g2D.drawImage(backupImage,null,0,0);
            return selectedImage; 
        }*/ 
        else {
            return new BufferedImage(10,10,BufferedImage.TYPE_INT_RGB);
        }
    }
    
    public void myDrawImage(Color rightColor) {
    	
    	if (drawOpaque == true) {
    		g2D.drawImage(pastedImage,null,pasteX,pasteY);
    	} else {
    		for (int countX = 0;countX < pastedImage.getWidth(); countX++) {
    			for (int countY = 0;countY < pastedImage.getHeight(); countY++) {
    				if (rightColor.getRGB() != pastedImage.getRGB(countX,countY)) {
    					try {
    						curImage.setRGB(pasteX+countX,pasteY+countY,pastedImage.getRGB(countX,countY));
    					} catch (Exception e) {}
    				}
    			}
    		}
    	}
    }
    				    
    public BufferedImage getCutImage(main_canvas theCanvas) {
        int temp;
        if (pasted == true) {
            g2D.drawImage(backupImage,null,0,0);
            //g2D.setColor(theCanvas.right_color);
            //g2D.fill(new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight()));
            //backupImage = theCanvas.getBufferedImage();
            //curImage = theCanvas.getBufferedImage();
            //g2D = curImage.createGraphics();
            //theCanvas.setBufferedImage(curImage);
            selected = false;
            pasted = false;
            moved = false;
            theCanvas.repaint();
            return pastedImage;
        }
        if (selected == true) {
            g2D.drawImage(backupImage,null,0,0);
            if (endX < startX) {
                temp = endX;
                endX = startX;
                startX = temp;
            }
            if (endY < startY) {
                temp = endY;
                endY = startY;
                startY = temp;
            }
            g2D.setColor(theCanvas.right_color);
            g2D.fill(new Rectangle(startX,startY,Math.abs(startX-endX),Math.abs(startY-endY)));
            backupImage = theCanvas.getBufferedImage();
            curImage = theCanvas.getBufferedImage();
            g2D = curImage.createGraphics();
            theCanvas.setBufferedImage(curImage);
            theCanvas.repaint();
            selected = false;
            pasted = false;
            moved = false;
            return selectedImage;
        } else {
            return new BufferedImage(10,10,BufferedImage.TYPE_INT_RGB);
        }
    }
    
    public void setPastedImage(BufferedImage theImage, main_canvas theCanvas) {
        int temp;
        
        if (pasted == true) {
            g2D.drawImage(backupImage,null,0,0);
            //g2D.drawImage(selectedImage,null,pasteX,pasteY);
            myDrawImage(theCanvas.right_color);
        } else if (selected == true){
            g2D.drawImage(backupImage,null,0,0);
        }
        pastedImage = theImage;
        curImage = theCanvas.getBufferedImage();
        backupImage = theCanvas.getBufferedImage();
        g2D = curImage.createGraphics();
        //g2D.drawImage(pastedImage,null,0,0);
        myDrawImage(theCanvas.right_color);
        pasteX = 0;
        pasteY = 0;
        g2D.setColor(Color.black);
        g2D.setStroke(selectStroke);
        g2D.draw(new Rectangle(pasteX,pasteY,pastedImage.getWidth(),pastedImage.getHeight()));
        theCanvas.setBufferedImage(curImage);
        pasted = true;
        selected = true;
        theCanvas.repaint();
    }
    
    public void deSelect(main_canvas theCanvas) {
    	if (selected == true) {
    		g2D.drawImage(backupImage,null,0,0);
    		if (drawOpaque == false) {
    			myDrawImage(theCanvas.right_color);
    		} else {
    			g2D.drawImage(pastedImage,null,pasteX,pasteY);
    		}
    		selected = false;
    		pasted = false;
    		moved = false;
    		theCanvas.repaint();
    	}
    }
    
    public void setOpaque(boolean value) { drawOpaque = value; }
    
    public void clear(main_canvas theCanvas) {
    	if (selected == true) {
    		g2D.setColor(theCanvas.right_color);
    		g2D.fill(new Rectangle(pasteX,pasteY,pasteX+selectedImage.getWidth(),pasteY+selectedImage.getHeight()));
    		selected = false;
    		moved = false;
    		pasted = false;
    	} else if (pasted == true) {
    		g2D.drawImage(backupImage,null,0,0);
    		selected = false;
    		moved = false;
    		pasted = false;
    	}
    	theCanvas.repaint();
    }
}
