//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//CMSC435  EditMenuOp (some of the code is adapted from
//                        SharpTools project )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

import java.awt.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import java.awt.datatransfer.*;
import java.util.*;
//****************************************************************
// Class: EditMenuOp
// Description:  This class will implement all the functions for the
//               edit menu
//Disclaimer: Some of the code and and ideas we found online in
//            the ShartTools project.  We thank them for making
//            their code availible.
//*************************************************************
public class EditMenuOp implements ClipboardOwner
{
    UMSpreadSheet m_spreadsheet;
    private int cnt=0;
    private JTable table;
    private UMTableModel tablemodel;
    private Clipboard clipboard = null;
    private CellPoint copypt=new CellPoint(UMSpreadSheet.m_baseRow, UMSpreadSheet.m_baseCol);
    //************************************************************
    // Public Constructor: EditMenuOp
    // Description: This constructs the FileMenuOp and set the parent
    //              application
    //
    // Parameters:
    //     spreadsheet   - the UMSpreadSheet application
    //*************************************************************
    public EditMenuOp(UMSpreadSheet spreadsheet)
    {
	m_spreadsheet = spreadsheet;
        table=spreadsheet.getTable();
        tablemodel=spreadsheet.getTableModel();
    }

    //***************************************************************
    // Public Method: cutOp
    // Description: This will perform the cut operation
    //**************************************************************
    public void cutOp(){
            //true to enable a clear operatn after the copy
           Copy(true);
    }

    //*************************************************************************
    //Private Method: Copy
    //Description :Since Copy and cut involve the same process of copying to
    //the clip board, Copy achieves that function and it clears the range if it
    //is a cut operation
    //*************************************************************************
    private void Copy(boolean clear)
    {

      if(table.getSelectedRowCount() != 0){
        cnt++;
        tablemodel.setModified(true);
        String text, simpleText;
        CellRange range= tablemodel.getSelection();
        //StringBuffer buff=new StringBuffer();
        int startRow=table.getSelectedRow();
        int startCol=table.getSelectedColumn();
        int numrows=table.getSelectedRowCount();
        int numcols=table.getSelectedColumnCount();
        copypt=new CellPoint (startRow, startCol);
        simpleText = tablemodel.toString1(range, true);
        text=tablemodel.toString1(range, false);
        //System.out.print("Text: \n"+text+"\nSimpleText\n"+simpleText);
        UMClipObj strsel=new UMClipObj(simpleText, text,
                                           range);

        //StringSelection strsel = new StringSelection(text);
        System.out.println("Created this new thing");
        clipboard=Toolkit.getDefaultToolkit().getSystemClipboard();
        if(clear)
          tablemodel.clearRange(range);
        try{
          clipboard.setContents(strsel,this);
          } catch(NullPointerException e){
            //System.out.println("Caught Exceptions");
            clipboard.setContents(strsel,this);
            //System.out.println("I am fine");
          }catch (Exception e){
            //System.out.println("Caught 2nd exception");
          }
    }
}

    //***************************************************************
    // Public Method: copyOp
    // Description: This will perform copy operation
    //**************************************************************
    public void copyOp(){
      Copy(false);
    }

    //***************************************************************
    // Public Method: pasteOp
    // Description: This will perform paste operation
    //SHOULD CONTINUE AFTER CUT HAS BEEN DONE
    //**************************************************************
    public void pasteOp(){
      SwingUtilities.invokeLater(new Runnable() {
        public void run() {
        String fromClip=null;
        CellRange affected=null;
        int size[]=null;
        Object frm=null;
        LinkedList t=null;
        if(table.getSelectedRowCount() != 0){
          int startRow=table.getSelectedRow();
          int startCol=table.getSelectedColumn(), rowOff=startRow-copypt.getRow();
          int colOff=startCol-copypt.getCol();
          //System.out.println("Paste Start Point: "+startRow+","+startCol);
          //System.out.println("Column off: "+colOff+" Row Off: "+rowOff);

          int endRow=0, endCol=0;
          int tabrows=table.getRowCount(), tabcols=table.getColumnCount();

          clipboard=Toolkit.getDefaultToolkit().getSystemClipboard();

          if (clipboard == null)
            {
                System.out.println("Clipboard is null");
                return;
            }

          //NOT WORKING TRY TO FIX
            try{
              Object obj = clipboard.getContents(this);
              if (obj != null &&
                obj instanceof TerpClipboardInterface )
              {
                //System.out.println("TerpItf");
                TerpClipboardInterface terpItf = (TerpClipboardInterface) obj;
                if (terpItf.copiedFrom() == TerpClipboardInterface.SPREADSHEET)
                    fromClip = ((UMClipObj) terpItf).getFormatedString();
                else
                    fromClip = terpItf.getString();
              }
              else if (obj != null)
              {
                 System.out.println("before getting stuff"); 
                fromClip=(clipboard.getContents(this).getTransferData(java.awt.datatransfer.DataFlavor.stringFlavor)).toString();
                System.out.println("getting stuff");
              }
              if (fromClip == null)
                fromClip = "";

              size=getSize(fromClip);
              //System.out.println("From Clip Board\n: "+fromClip);

            } catch(Exception e){
              System.out.println("Error in Paste");
              System.out.println("Error Msg: "+e.getMessage());
              e.printStackTrace(System.out);
            }
            tablemodel.setModified(true);
            endRow=Math.min(tabrows-1, startRow+size[0]-1);
            endCol=Math.min(tabcols-1, startCol+size[1]-1);
            affected=new CellRange(startRow, endRow, startCol, endCol);
            tablemodel.fromString1(fromClip, rowOff, colOff, affected);
          }
        }
      }
      );
    }

    //***************************************************************
    // Public Method: getSize
    // Description: This get the row/col size of the string coming from Clipboard
    //**************************************************************
    public int [] getSize(String input) {

	BufferedReader in = new BufferedReader(new StringReader(input));
	String line;
	int rowcount = 0;
	int colcount = 0;
	try {

	    while ((line = in.readLine()) != null) {
		rowcount++;
		// initialize new tokenizer on line with tab delimiter.
		//		tokenizer = new StringTokenizer(line, "\t");
		int index;
		int prev = 0;

		// set col to 1 before each loop
		int col = 0;

		while (true) {
		    index = line.indexOf('\t', prev);
		    prev = index+1;
		    // increment column number
		    col++;

		    if (index == -1)
			break;
		}
		if (colcount < col)
		    colcount = col;
	    }
	}
	catch (Exception e) {
	    return null;
	}
	//	System.out.println(new CellPoint(rowcount, colcount));
        int a[]=new int[2];
        a[0]=rowcount;
        a[1]=colcount;

        return a;
    }

    //***************************************************************
    // Public Method: clearOp
    // Description: This will perform clear operation
    //**************************************************************
    public void clearOp(){
      if(table.getSelectedRowCount() != 0){
        CellRange range=new CellRange(table.getSelectedRows(),
                                      table.getSelectedColumns());
        tablemodel.clearRange(range);
        tablemodel.setModified(true);
      }
    }

    //***************************************************************
    //Public Method: getFontIndex
    //Description returns the index of a font from the system fontlist available
    //***************************************************************
    public static int getFontIndex(String fname){
      java.awt.GraphicsEnvironment ge =
            java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment();
      String[] fontNames = ge.getAvailableFontFamilyNames();
      int index=-2;
      for(int x=0;x<fontNames.length;x++){
        if(fontNames[x].equals(fname)){
          index=x;
          break;
        }
      }
      return index;
    }

    public void lostOwnership(Clipboard clipboard,
                              Transferable transferable)
    {
        System.out.println ("Lost ownership!!!");
    }

}







